/*-
 * ~~~~~~licensing~~~~~~
 * object-producing-resources-support
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.producer.resources.generator;

import java.util.HashMap;
import java.util.Map;

import ru.entaxy.esb.platform.runtime.base.connecting.generator.Generated;
import ru.entaxy.platform.core.producer.resources.ResourceDescriptor;
import ru.entaxy.platform.core.producer.resources.ResourceProducer;

public class GeneratedResourceWrapper implements Generated {

    public static final String OBJECT_KEY = "#_object";

    protected Map<String, Object> properties = new HashMap<>();

    public GeneratedResourceWrapper(Map<String, Object> props) {
        this.properties.putAll(props);
        Map<String, Object> resourceReference = new HashMap<>();
        String reference = String.format("%s:%s", props.get("provider"), props.get("location"));
        resourceReference.put("@RESOURCE_REF", reference);
        this.properties.put(ResourceProducer.PROP_RESOURCE_REFERENCE, resourceReference);
    }

    @Override
    public String getType() {
        return this.properties.getOrDefault("generated.targetType",
                ResourceDescriptor.RESOURCE_TYPE_PREFIX + properties.getOrDefault("type", "unknown")).toString();
    }

    @Override
    public Object getObject() {
        return this.properties.get(OBJECT_KEY);
    }

    @Override
    public Map<String, Object> getProperties() {
        return this.properties;
    }

}
